﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Windows.Ria;
using SilverlightApplication6.Web;
using System.ComponentModel;
using System.Collections;

namespace SilverlightApplication6.ViewModel
{
    public class OrdersViewModel : INotifyPropertyChanged
    {
        private TestDomainContext _orderContext = new TestDomainContext();
        private IEnumerable<Entity> _orders;
        public IEnumerable<Entity> Orders
        {
            get
            {
                if (_orders == null)
                {
                    LoadOperation loadOp = this._orderContext.Load(this._orderContext.GetOrderQuery());
                    _orders = loadOp.Entities;
                }
                return _orders;
            }
        }

        private Order _selectedOrder;
        public Order SelectedOrder
        {
            get
            {
                if (_selectedOrder == null)
                {
                    //chart doesnt currently like being bound to null data
                    //so make sure it has some data till the read data arrives.
                    _selectedOrder = GetMockOrder();
                }
                return _selectedOrder;
            }
            set
            {
                _selectedOrder = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("SelectedOrder"));
                }
                if (Visible != Visibility.Visible)
                {
                    Visible = Visibility.Visible;
                }
            }
        }

        private Visibility _visible = Visibility.Collapsed;
        public Visibility Visible
        {
            get
            {
                return _visible;
            }
            set
            {
                _visible = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Visible"));
                }
            }
        }

        private Order GetMockOrder()
        {
            Order mock = new Order();
            OrderLine mockLine = new OrderLine();
            mockLine.Description = "1";
            mockLine.Total = 1;
            mock.OrderLine.Add(mockLine);
            return mock;
        }

        public void OnSelectedOrderChanged(object obj)
        {
            if (obj != null && obj is int)
            {
                int index = (int)obj;
                int count = 0;
                foreach (Order _item in Orders)
                {
                    if (count == index)
                    {
                        SelectedOrder = _item;
                        break;
                    }
                    count++;
                }
            }
        }

        public bool CanSelectedOrderChanged()
        {
            return true;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}
